## libftdi1 1.6~rc1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15 FATAL_ERROR)

message(STATUS "CMake version: ${CMAKE_VERSION}")

# Project
project(libftdi1 C)
set(MAJOR_VERSION 1)
set(MINOR_VERSION 6)
set(PACKAGE libftdi1)
set(VERSION_STRING ${MAJOR_VERSION}.${MINOR_VERSION}rc1)
set(VERSION ${VERSION_STRING})
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

# Target link properties INTERFACE_LINK_OPTIONS, INTERFACE_LINK_DIRECTORIES
# and INTERFACE_LINK_DEPENDS are now transitive over private dependencies
# of static libraries
if (POLICY CMP0099)
    cmake_policy(SET CMP0099 NEW)
endif ()

# CMake
if ("${CMAKE_BUILD_TYPE}" STREQUAL "")
    set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif ("${CMAKE_BUILD_TYPE}" STREQUAL "")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

if (NOT PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
    # Auto-create a .gitignore in the out-of-source build directory.
    file(GENERATE OUTPUT .gitignore CONTENT "*")
endif ()

include(GNUInstallDirs)

add_definitions(-Wall)

include(CMakeOptions.txt)

# Debug build
message("-- Build type: ${CMAKE_BUILD_TYPE}")
if (${CMAKE_BUILD_TYPE} STREQUAL Debug)
    add_definitions(-DDEBUG)
endif (${CMAKE_BUILD_TYPE} STREQUAL Debug)

# Find libusb
find_package(LibUSB REQUIRED)
include_directories(${LIBUSB_INCLUDE_DIR})

# Set components
set(CPACK_COMPONENTS_ALL sharedlibs staticlibs headers)
set(CPACK_COMPONENT_SHAREDLIBS_DISPLAY_NAME "Shared libraries")
set(CPACK_COMPONENT_STATICLIBS_DISPLAY_NAME "Static libraries")
set(CPACK_COMPONENT_HEADERS_DISPLAY_NAME "C++ Headers")

set(CPACK_COMPONENT_SHAREDLIBS_DESCRIPTION
        "Shared library for general use.")
set(CPACK_COMPONENT_STATICLIBS_DESCRIPTION
        "Static library, good if you want to embed libftdi1 in your application.")
set(CPACK_COMPONENT_HEADERS_DESCRIPTION
        "C/C++ header files.")

set(CPACK_COMPONENT_SHAREDLIBS_GROUP "Development")
set(CPACK_COMPONENT_STATICLIBS_GROUP "Development")
set(CPACK_COMPONENT_HEADERS_GROUP "Development")

# guess LIB_SUFFIX, don't take debian multiarch into account
if (NOT DEFINED LIB_SUFFIX)
    if (CMAKE_SYSTEM_NAME MATCHES "Linux"
            AND NOT CMAKE_CROSSCOMPILING
            AND NOT EXISTS "/etc/debian_version"
            AND NOT EXISTS "/etc/arch-release")
        if ("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
            set(LIB_SUFFIX 64)
        endif ()
    endif ()
endif ()

if (NOT APPLE)
    if (CMAKE_SIZEOF_VOID_P EQUAL 4)
        SET(PACK_ARCH "")
    elseif (CMAKE_SIZEOF_VOID_P EQUAL 8)
        SET(PACK_ARCH .x86_64)
    endif (CMAKE_SIZEOF_VOID_P EQUAL 4)
else (NOT APPLE)
    SET(PACK_ARCH "")
endif (NOT APPLE)

# Package information
set(CPACK_PACKAGE_VERSION ${VERSION_STRING})
set(CPACK_PACKAGE_CONTACT "Intra2net AG <libftdi@developer.intra2net.com>")
set(CPACK_PACKAGE_DESCRIPTION "libftdi1 library.")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${CPACK_PACKAGE_DESCRIPTION})

# Package settings
if (UNIX)
    set(CPACK_GENERATOR "DEB;RPM")
    set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
    set(CPACK_PACKAGE_NAME ${PROJECT_NAME})
    set(CPACK_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}${PACK_ARCH})
endif ()

if (WIN32)
    set(CPACK_GENERATOR "NSIS")
    set(CPACK_CMAKE_GENERATOR "MinGW Makefiles")
    set(CPACK_PACKAGE_NAME "${PROJECT_NAME}")
    set(CPACK_PACKAGE_VENDOR "")
    set(CPACK_PACKAGE_INSTALL_DIRECTORY "libftdi1")
    set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION_STRING}-win32")
    set(CPACK_NSIS_DISPLAY_NAME "libftdi1")
    set(CPACK_NSIS_MODIFY_PATH ON)
endif ()

set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE)

set(CPACK_SOURCE_GENERATOR TGZ)
set(CPACK_SOURCE_IGNORE_FILES "\\\\.git;~$;build/")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION})

# Subdirectories
if (UNIX)
    set(CPACK_SET_DESTDIR ON)
endif ()

# "make dist" target
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${VERSION_STRING})
add_custom_target(dist
        COMMAND git archive --prefix=${ARCHIVE_NAME}/ HEAD
        | bzip2 > ${PROJECT_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_subdirectory(src)
add_subdirectory(packages)

if (DOCUMENTATION)
    add_subdirectory(doc)
endif (DOCUMENTATION)

if (FTDIPP)
    project(libftdi1 C CXX)
    add_subdirectory(ftdipp)
endif (FTDIPP)

if (PYTHON_BINDINGS)
    add_subdirectory(python)
endif (PYTHON_BINDINGS)

if (FTDI_EEPROM)
    add_subdirectory(ftdi_eeprom)
endif (FTDI_EEPROM)

if (EXAMPLES)
    add_subdirectory(examples)
endif (EXAMPLES)

if (BUILD_TESTS)
    project(libftdi1 C CXX)
    add_subdirectory(test)
endif (BUILD_TESTS)

# PkgConfig
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX}/bin)
set(includedir ${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME})

if (${UNIX})
    set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
endif (${UNIX})
if (${WIN32})
    set(libdir ${CMAKE_INSTALL_PREFIX}/bin)
    if (STATICLIBS)
        list(APPEND libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
    endif ()
endif (${WIN32})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libftdi1.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libftdi1.pc @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libftdipp1.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libftdipp1.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libftdi1.pc ${CMAKE_CURRENT_BINARY_DIR}/libftdipp1.pc
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

if (UNIX OR MINGW)
    configure_file(libftdi1-config.in ${CMAKE_CURRENT_BINARY_DIR}/libftdi1-config @ONLY)
    install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/libftdi1-config
            DESTINATION bin)
endif ()

# config script install path
if (NOT DEFINED LIBFTDI_CMAKE_CONFIG_DIR)
    set(LIBFTDI_CMAKE_CONFIG_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/libftdi1)
endif ()

set(LIBFTDI_INCLUDE_DIR ${includedir})
set(LIBFTDI_INCLUDE_DIRS ${LIBFTDI_INCLUDE_DIR})

# Set up library variables based on what's being built
if (SHAREDLIBS)
    set(LIBFTDI_LIBRARY ftdi1)
    set(LIBFTDI_LIBRARIES ${LIBFTDI_LIBRARY})
    list(APPEND LIBFTDI_LIBRARIES ${LIBUSB_LIBRARIES})
endif ()

if (STATICLIBS)
    set(LIBFTDI_STATIC_LIBRARY ftdi1.a)
    set(LIBFTDI_STATIC_LIBRARIES ${LIBFTDI_STATIC_LIBRARY})
    list(APPEND LIBFTDI_STATIC_LIBRARIES ${LIBUSB_LIBRARIES})
endif ()

if (FTDIPP)
    if (SHAREDLIBS)
        set(LIBFTDIPP_LIBRARY ftdipp1)
        set(LIBFTDIPP_LIBRARIES ${LIBFTDIPP_LIBRARY})
        list(APPEND LIBFTDIPP_LIBRARIES ${LIBUSB_LIBRARIES})
    endif ()
    if (STATICLIBS)
        set(LIBFTDIPP_STATIC_LIBRARY ftdipp1.a)
        set(LIBFTDIPP_STATIC_LIBRARIES ${LIBFTDIPP_STATIC_LIBRARY})
        list(APPEND LIBFTDIPP_STATIC_LIBRARIES ${LIBUSB_LIBRARIES})
    endif ()
endif ()

set(LIBFTDI_LIBRARY_DIRS ${libdir})
set(LIBFTDI_ROOT_DIR ${prefix})
set(LIBFTDI_VERSION_STRING ${VERSION_STRING})
set(LIBFTDI_VERSION_MAJOR ${MAJOR_VERSION})
set(LIBFTDI_VERSION_MINOR ${MINOR_VERSION})

set(LIBFTDI_USE_FILE ${CMAKE_INSTALL_PREFIX}/${LIBFTDI_CMAKE_CONFIG_DIR}/UseLibFTDI1.cmake)

include(CMakePackageConfigHelpers)

configure_package_config_file(
        cmake/LibFTDI1Config.cmake.in
        ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1Config.cmake
        INSTALL_DESTINATION ${LIBFTDI_CMAKE_CONFIG_DIR}
        PATH_VARS
        LIBFTDI_USE_FILE
        LIBFTDI_ROOT_DIR
        LIBFTDI_INCLUDE_DIR
        LIBFTDI_INCLUDE_DIRS
        LIBFTDI_LIBRARY_DIRS
        NO_CHECK_REQUIRED_COMPONENTS_MACRO
)
write_basic_package_version_file(
        LibFTDI1ConfigVersion.cmake
        VERSION ${LIBFTDI_VERSION_STRING}
        COMPATIBILITY AnyNewerVersion
)

install(
        FILES
        ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1Config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/LibFTDI1ConfigVersion.cmake
        cmake/UseLibFTDI1.cmake
        DESTINATION ${LIBFTDI_CMAKE_CONFIG_DIR}
)

include(CPack)

message(STATUS "Summary of build options:

  Build shared libs: ${SHAREDLIBS}
  Build static libs: ${STATICLIBS}
  Build C++ bindings: ${FTDIPP}
  Build Python bindings: ${PYTHON_BINDINGS}
  Build ftdi_eeprom: ${FTDI_EEPROM}
  Build examples: ${EXAMPLES}
  Build tests: ${BUILD_TESTS}
  Build API documentation: ${DOCUMENTATION}
")

=== doc/CMakeLists.txt ===
 find_package(Doxygen REQUIRED)

 # Copy doxy.config.in
 configure_file(
         ${PROJECT_SOURCE_DIR}/doc/Doxyfile.in
         ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
 )

 configure_file(
         ${PROJECT_SOURCE_DIR}/doc/Doxyfile.xml.in
         ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile.xml
 )

 # Run doxygen
 add_custom_command(
         OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
         COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
         COMMENT "Generating API documentation"
         DEPENDS ${c_headers};${c_sources};${cpp_sources};${cpp_headers}
 )

 add_custom_target(
         docs ALL
         COMMENT "Documentation target docs"
         DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/html/index.html
 )

=== examples/CMakeLists.txt ===
# Includes
include_directories(${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_CURRENT_BINARY_DIR}
)

# Targets
add_executable(simple simple.c)
add_executable(bitbang bitbang.c)
add_executable(bitbang2 bitbang2.c)
add_executable(bitbang_cbus bitbang_cbus.c)
add_executable(bitbang_ft2232 bitbang_ft2232.c)
add_executable(find_all find_all.c)
add_executable(serial_test serial_test.c)
add_executable(baud_test baud_test.c)
add_executable(stream_test stream_test.c)
add_executable(eeprom eeprom.c)
add_executable(async async.c)
if (NOT MINGW)
    add_executable(purge_test purge_test.c)
endif (NOT MINGW)

# Linkage
target_link_libraries(simple ftdi1)
target_link_libraries(bitbang ftdi1)
target_link_libraries(bitbang2 ftdi1)
target_link_libraries(bitbang_cbus ftdi1)
target_link_libraries(bitbang_ft2232 ftdi1)
target_link_libraries(find_all ftdi1)
target_link_libraries(serial_test ftdi1)
target_link_libraries(baud_test ftdi1)
target_link_libraries(stream_test ftdi1)
target_link_libraries(eeprom ftdi1)
target_link_libraries(async ftdi1)
if (NOT MINGW)
    target_link_libraries(purge_test ftdi1)
endif (NOT MINGW)

# libftdi++ examples
if (FTDIPP)
    include_directories(BEFORE ${PROJECT_SOURCE_DIR}/ftdipp
    )

    # Target
    add_executable(find_all_pp find_all_pp.cpp)

    # Linkage
    target_link_libraries(find_all_pp ftdipp1)
endif (FTDIPP)

# Source includes
include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src)

=== ftdi_eeprom/CMakeLists.txt ===
find_package(Confuse REQUIRED)
find_package(Libintl)

# determine docdir
include(GNUInstallDirs)
if (NOT CMAKE_INSTALL_DOCDIR)
    if (WIN32)
        set(CMAKE_INSTALL_DOCDIR .)
    else (WIN32)
        set(CMAKE_INSTALL_DOCDIR ${CMAKE_INSTALL_DATAROOTDIR}/doc/${PROJECT_NAME})
    endif (WIN32)
endif (NOT CMAKE_INSTALL_DOCDIR)

message(STATUS "Building ftdi_eeprom")

include_directories(${CONFUSE_INCLUDE_DIRS})
list(APPEND libs ${CONFUSE_LIBRARIES})

if (LIBINTL_FOUND)
    include_directories(${LIBINTL_INCLUDE_DIR})
    list(APPEND libs ${LIBINTL_LIBRARIES})
endif ()


# Version defines
set(EEPROM_MAJOR_VERSION 0)
set(EEPROM_MINOR_VERSION 17)
set(EEPROM_VERSION_STRING ${EEPROM_MAJOR_VERSION}.${EEPROM_MINOR_VERSION})

include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src)
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

configure_file(
        ftdi_eeprom_version.h.in
        ${CMAKE_CURRENT_BINARY_DIR}/ftdi_eeprom_version.h
)

add_executable(ftdi_eeprom main.c)
if (NOT SHAREDLIBS AND STATICLIBS)
    target_link_libraries(ftdi_eeprom ftdi1-static)
else()
    target_link_libraries(ftdi_eeprom ftdi1)
endif ()
target_link_libraries(ftdi_eeprom ${CONFUSE_LIBRARIES})
if (LIBINTL_FOUND)
    target_link_libraries(ftdi_eeprom ${LIBINTL_LIBRARIES})
endif ()
if (NOT SHAREDLIBS AND STATICLIBS)
    target_link_libraries(ftdi_eeprom ${LIBUSB_LIBRARIES})
endif ()
install(TARGETS ftdi_eeprom DESTINATION bin)
install(FILES example.conf DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== ftdipp/CMakeLists.txt ===
# Targets
set(cpp_sources ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.cpp CACHE INTERNAL "List of cpp sources")
set(cpp_headers ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.hpp CACHE INTERNAL "List of cpp headers")

# Includes
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${PROJECT_SOURCE_DIR}/src
)

# Shared library
if (SHAREDLIBS)
    add_library(ftdipp1 SHARED ${cpp_sources})
    math(EXPR VERSION_FIXUP "${MAJOR_VERSION} + 1")    # Compatibility with previous releases
    set_target_properties(ftdipp1 PROPERTIES VERSION ${VERSION_FIXUP}.${MINOR_VERSION}.0 SOVERSION 3)
    # Prevent clobbering each other during the build
    set_target_properties(ftdipp1 PROPERTIES CLEAN_DIRECT_OUTPUT 1)
    # Dependencies
    target_link_libraries(ftdipp1 ftdi1 ${LIBUSB_LIBRARIES})
    install(TARGETS ftdipp1
            RUNTIME DESTINATION bin
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ()

# Static library
if (STATICLIBS)
    add_library(ftdipp1-static STATIC ${cpp_sources})
    set_target_properties(ftdipp1-static PROPERTIES OUTPUT_NAME "ftdipp1")
    set_target_properties(ftdipp1-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
    target_link_libraries(ftdipp1-static ftdi1-static ${LIBUSB_LIBRARIES})
    install(TARGETS ftdipp1-static
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT staticlibs
    )
endif ()

install(FILES ${cpp_headers}
        DESTINATION include/${PROJECT_NAME}
        COMPONENT headers
)

=== packages/CMakeLists.txt ===
# Debian
if ("${PACKAGE}" STREQUAL "Debian")

    # Settings
    set(REVISION 0)
    set(CPACK_GENERATOR "DEB" PARENT_SCOPE)
    set(CPACK_PACKAGE_VERSION ${CPACK_PACKAGE_VERSION}-${REVISION} PARENT_SCOPE)

    # Dependencies
    set(CPACK_DEBIAN_PACKAGE_DEPENDS "libusb-1.0-0" PARENT_SCOPE)
    set(DEBIAN_PACKAGE_BUILDS_DEPENDS "cmake, libusb2-dev" PARENT_SCOPE)

    # Bundles
    message("-- Installing udev rules to /etc/udev/rules.d")
    install(FILES 99-libftdi.rules
            DESTINATION /etc/udev/rules.d)

endif ("${PACKAGE}" STREQUAL "Debian")

# General RPM rules
set(CPACK_RPM_PACKAGE_DEPENDS "libusb1" PARENT_SCOPE)

=== python/CMakeLists.txt ===
# workaround for cmake bug #0013449
if (NOT DEFINED CMAKE_FIND_ROOT_PATH OR NOT CMAKE_VERSION VERSION_LESS 3.0.0)
    find_package(SWIG REQUIRED)
else ()
    find_program(SWIG_EXECUTABLE NAMES swig2.0 swig)
    if (SWIG_EXECUTABLE)
        set(SWIG_USE_FILE ${CMAKE_ROOT}/Modules/UseSWIG.cmake)
        set(SWIG_FOUND TRUE)
    endif ()
endif ()
find_package(Python3 COMPONENTS Interpreter Development)

include(UseSWIG)
include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src)
include_directories(${Python3_INCLUDE_DIRS})
link_directories(${CMAKE_CURRENT_BINARY_DIR}/../src)

if (DOCUMENTATION)
    set(CMAKE_SWIG_FLAGS -DDOXYGEN=${DOXYGEN_FOUND})
    # manually add dependency for new cmake / swig versions
    set_property(SOURCE ftdi1.i PROPERTY DEPENDS doc_i)
endif ()
swig_add_library(pyftdi1 LANGUAGE python SOURCES ftdi1.i)
swig_link_libraries(pyftdi1 ftdi1)

if (LINK_PYTHON_LIBRARY)
    swig_link_libraries(pyftdi1 ${PYTHON_LIBRARIES})
elseif (APPLE)
    set_target_properties(pyftdi1 PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
endif ()

set_target_properties(pyftdi1 PROPERTIES NO_SONAME ON)

execute_process(COMMAND ${Python3_EXECUTABLE} -c "import sysconfig; print( sysconfig.get_path( 'platlib', vars={'platbase': '${CMAKE_INSTALL_PREFIX}'} ) )"
        OUTPUT_VARIABLE _ABS_PYTHON_MODULE_PATH
        OUTPUT_STRIP_TRAILING_WHITESPACE)

get_filename_component(_ABS_PYTHON_MODULE_PATH ${_ABS_PYTHON_MODULE_PATH} ABSOLUTE)
file(RELATIVE_PATH _REL_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX} ${_ABS_PYTHON_MODULE_PATH})

set(PYTHON_MODULE_PATH ${_REL_PYTHON_MODULE_PATH})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ftdi1.py DESTINATION ${PYTHON_MODULE_PATH})
install(TARGETS pyftdi1 LIBRARY DESTINATION ${PYTHON_MODULE_PATH})

if (DOCUMENTATION)
    # Run doxygen to only generate the xml
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doc/xml/ftdi_8c.xml
            COMMAND ${DOXYGEN_EXECUTABLE} ${PROJECT_BINARY_DIR}/doc/Doxyfile.xml
            WORKING_DIRECTORY ${PROJECT_BINARY_DIR}
            COMMENT "Generating ftdi_8c.xml"
            DEPENDS ${c_headers};${c_sources};${cpp_sources};${cpp_headers}
    )

    # generate .i from doxygen .xml
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i
            COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/doxy2swig.py -n
            ${PROJECT_BINARY_DIR}/doc/xml/ftdi_8c.xml
            ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i
            COMMENT "Generating ftdi1_doc.i from ftdi_8c.xml"
            DEPENDS ${PROJECT_BINARY_DIR}/doc/xml/ftdi_8c.xml
    )
    add_custom_target(doc_i
            COMMENT "Python API bindings documentation"
            DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/ftdi1_doc.i
    )
    add_dependencies(pyftdi1 doc_i)

endif (DOCUMENTATION)

set(LIBFTDI_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX}/${PYTHON_MODULE_PATH})
set(LIBFTDI_PYTHON_MODULE_PATH ${LIBFTDI_PYTHON_MODULE_PATH} PARENT_SCOPE) # for ftdiconfig.cmake

add_subdirectory(examples)

=== src/CMakeLists.txt ===
# Includes
include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
)

# Version information
set(SNAPSHOT_VERSION "unknown")
execute_process(COMMAND git describe
        OUTPUT_VARIABLE GIT_DESCRIBE_OUTPUT
        RESULT_VARIABLE GIT_DESCRIBE_RESULT
        OUTPUT_STRIP_TRAILING_WHITESPACE
)
if (${GIT_DESCRIBE_RESULT} STREQUAL 0)
    set(SNAPSHOT_VERSION ${GIT_DESCRIBE_OUTPUT})
endif ()
message(STATUS "Detected git snapshot version: ${SNAPSHOT_VERSION}")

configure_file(ftdi_version_i.h.in "${CMAKE_CURRENT_BINARY_DIR}/ftdi_version_i.h" @ONLY)

if (MSVC)
    # Disable some overly-verbose warnings activated by -Wall

    # '<name>': function not inlined
    add_compile_options(/wd4710)

    # function '<name>' selected for automatic inline expansion
    add_compile_options(/wd4711)

    # Compiler will insert Spectre mitigation for memory load if /Qspectre switch specified
    add_compile_options(/wd5045)

    # '<type>': '4' bytes padding added after data member '<name>'
    add_compile_options(/wd4820)

    # conversion from '<type1>' to '<type2>', possible loss of data
    add_compile_options(/wd4242 /wd4244 /wd4267)

    # Disable warning on unsafe string functions
    add_compile_definitions(_CRT_SECURE_NO_WARNINGS)

    if (MSVC_VERSION GREATER_EQUAL 1913)
        # Disable warnings from system headers
        add_compile_options(/external:anglebrackets /external:W0)
    endif ()
endif ()

# Targets
set(c_sources ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.c ${CMAKE_CURRENT_SOURCE_DIR}/ftdi_stream.c CACHE INTERNAL "List of c sources")
set(c_headers ${CMAKE_CURRENT_SOURCE_DIR}/ftdi.h CACHE INTERNAL "List of c headers")

# Shared library
if (SHAREDLIBS)
    add_library(ftdi1 SHARED ${c_sources})
    math(EXPR VERSION_FIXUP "${MAJOR_VERSION} + 1")    # Compatibility with previous releases
    set_target_properties(ftdi1 PROPERTIES VERSION ${VERSION_FIXUP}.${MINOR_VERSION}.0 SOVERSION 2)
    # Prevent clobbering each other during the build
    set_target_properties(ftdi1 PROPERTIES CLEAN_DIRECT_OUTPUT 1)
    target_link_libraries(ftdi1 ${LIBUSB_LIBRARIES})
    install(TARGETS ftdi1
            RUNTIME DESTINATION bin
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif ()

# Static library
if (STATICLIBS)
    add_library(ftdi1-static STATIC ${c_sources})
    target_link_libraries(ftdi1-static ${LIBUSB_LIBRARIES})
    set_target_properties(ftdi1-static PROPERTIES OUTPUT_NAME "ftdi1")
    set_target_properties(ftdi1-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
    install(TARGETS ftdi1-static
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            COMPONENT staticlibs
    )
endif ()

install(FILES ${c_headers}
        DESTINATION include/${PROJECT_NAME}
        COMPONENT headers
)

=== test/CMakeLists.txt ===
# Unit tests only: Modern Boost integration (CMake 3.30+)
# Use CMake's built-in Boost support instead of deprecated FindBoost module
# For CMake < 3.30, keep old behavior to avoid errors
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
    cmake_policy(SET CMP0167 NEW)
endif ()

# Make CMake respect variables like BOOST_ROOT even though we look for "Boost"
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.27)
    cmake_policy(SET CMP0144 NEW)
endif ()

# Find Boost unit test framework. We don't want to link that to libftdi1 itself.
find_package(Boost COMPONENTS unit_test_framework REQUIRED)

enable_testing()

# CMake 3.28 compatibility: include_directories only needed for CMake < 3.30
# (imported targets handle include paths automatically in CMake 3.30+)
if (CMAKE_VERSION VERSION_LESS 3.30)
    INCLUDE_DIRECTORIES(BEFORE ${Boost_INCLUDE_DIRS})
endif ()

INCLUDE_DIRECTORIES(BEFORE ${PROJECT_SOURCE_DIR}/src)

set(cpp_tests basic.cpp baudrate.cpp)

add_executable(test_libftdi1 ${cpp_tests})

# Use modern imported targets for CMake 3.30+, fallback to old-style variables
if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.30)
    target_link_libraries(test_libftdi1 ftdi1 Boost::unit_test_framework)
else ()
    target_link_libraries(test_libftdi1 ftdi1 ${Boost_UNIT_TEST_FRAMEWORK_LIBRARIES})
endif ()

add_test(test_libftdi1 test_libftdi1)

# Add custom target so we run easily run "make check"
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} DEPENDS test_libftdi1)

=== examples/cmake_example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

project(example C)

find_package(LibFTDI1 NO_MODULE REQUIRED)
include(${LIBFTDI_USE_FILE})

add_executable(example main.c)
target_link_libraries(example ${LIBFTDI_LIBRARIES})

install(TARGETS example
        DESTINATION bin
)

=== python/examples/CMakeLists.txt ===
 install(FILES simple.py complete.py cbus.py
         DESTINATION share/libftdi/examples
         PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
 )

=== debian/changelog ===
libftdi1 (1.6~rc1-1) unstable; urgency=medium

  * New upstream release candidate
  * Remove all patches, all merged upstream
  * Update symbols file
  * Update libftdipp1 symbols file to catch an architecture specific
    internal c++ symbol
  * Update debian/copyright
  * Update debian/watch to version 5
  * Stop forcing CMAKE_POLICY_VERSION_MINIMUM, new upstream version is
    compatible with CMake 4
  * debian/control: drop Rules-Requires-Root field, now obsolete
  * debian/control: drop Priority field, optional is now the default
  * Bump Standards-Version to 4.7.3 (no changes)

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 03 Jan 2026 13:52:23 +0100

libftdi1 (1.5-12) unstable; urgency=medium

  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113153)

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 01 Sep 2025 19:11:29 +0200

libftdi1 (1.5-11) unstable; urgency=medium

  * Make libboost-test-dev build-dependency optional via <!nocheck>. Thanks
    to Helmut Grohne <helmut@subdivi.de>
  * Backport 05-boost-dependency.diff from upstream, drop
    (build-)dependencies on libboost-dev, and adjust libftdipp1-3 symbols
    file.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 12 Aug 2025 11:33:34 +0200

=== debian/control ===
Source: libftdi1
Section: libs
Maintainer: Aurelien Jarno <aurel32@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libusb-1.0-0-dev, pkgconf
Build-Depends-Arch: dh-sequence-python3,
                    libboost-test-dev <!nocheck>,
                    libconfuse-dev,
                    libpython3-all-dev,
                    python3-all:any,
                    python3-setuptools,
                    swig
Build-Depends-Indep: doxygen
Standards-Version: 4.7.3
Homepage: https://www.intra2net.com/en/developer/libftdi/
Vcs-Git: https://salsa.debian.org/aurel32/libftdi1.git
Vcs-Browser: https://salsa.debian.org/aurel32/libftdi1

Package: ftdi-eeprom
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Tool for reading/erasing/flashing FTDI USB chip EEPROMs
 ftdi-eeprom is a small tool for creating and uploading the configuration
 EEPROM for the FTDI chip. This eeprom contains information such as vendor
 and product ID, manufacturer and product strings, revision, etc.

Package: libftdi1-2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C Library to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This is the C version of the library.

Package: libftdi1-dev
Section: libdevel
Architecture: any
Depends: libftdi1-2 (= ${binary:Version}), libusb-1.0-0-dev, ${misc:Depends}
Recommends: libftdi1-doc
Description: Development files for libftdi1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the header files and static library needed to
 compile applications that use libftdi1.

Package: libftdi1-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: libftdi1-dev
Description: Documentation for libftdi1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the documentation of the libftdi1 library.

Package: libftdipp1-3
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: C++ Library to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This is the C++ version of the library.

Package: libftdipp1-dev
Section: libdevel
Architecture: any
Recommends: libftdi1-doc
Depends: libftdi1-dev (= ${binary:Version}),
         libftdipp1-3 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for libftdipp1
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 This package contains the header files and static library needed to
 compile applications that use libftdipp1.

Package: python3-ftdi1
Section: python
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Description: Python module to control and program the FTDI USB controllers
 This library could talk to FTDI's FT232BM, FT245BM, FT2232C, FT2232D, FT245R,
 FT232H and FT230X type USB chips from userspace. It uses libusb 1.0 to
 communicate with the chips.
 .
 Functionalities include the possibility to use the chips in standard
 mode, in bitbang mode, and to read or write the serial EEPROM.
 .
 This package provides the ftdi1 module on the Python 3 module path.

=== debian/watch ===
Version: 5

Source: https://www.intra2net.com/en/developer/libftdi/download.php
Matching-Pattern: download/libftdi1-(.+)\.tar\.bz2
